# Uses of Class
org.apache.lucene.util.hnsw.HnswGraph

Packages that use HnswGraph
Package
Description
org.apache.lucene.codecs.hnsw
HNSW vector helper classes.
org.apache.lucene.codecs.lucene99
Lucene 9.9 file format.
org.apache.lucene.util.hnsw
Navigable Small-World graph, nominally Hierarchical but currently only has a single layer.

- ## Uses of HnswGraph in org.apache.lucene.codecs.hnsw

  Methods in org.apache.lucene.codecs.hnsw that return HnswGraph
  Modifier and Type
  Method
  Description
  `HnswGraph`
  HnswGraphProvider.`getGraph(String field)`
  Return the stored HnswGraph for the given field.

- ## Uses of HnswGraph in org.apache.lucene.codecs.lucene99

  Methods in org.apache.lucene.codecs.lucene99 that return HnswGraph
  Modifier and Type
  Method
  Description
  `HnswGraph`
  Lucene99HnswVectorsReader.`getGraph(String field)`

- ## Uses of HnswGraph in org.apache.lucene.util.hnsw

  Subclasses of HnswGraph in org.apache.lucene.util.hnsw
  Modifier and Type
  Class
  Description
  `final class`
  `OnHeapHnswGraph`
  An `HnswGraph` where all nodes and connections are held in memory.
  Fields in org.apache.lucene.util.hnsw declared as HnswGraph
  Modifier and Type
  Field
  Description
  `static final HnswGraph`
  HnswGraph.`EMPTY`
  Empty graph value
  Methods in org.apache.lucene.util.hnsw with parameters of type HnswGraph
  Modifier and Type
  Method
  Description
  `static IntHashSet`
  UpdateGraphsUtils.`computeJoinSet(HnswGraph graph)`
  Find nodes in the graph that best cover the graph.
  `static FilteredHnswGraphSearcher`
  FilteredHnswGraphSearcher.`create(int k, HnswGraph graph, int filterSize, Bits acceptOrds)`
  Creates a new filtered graph searcher.
  `static InitializedHnswGraphBuilder`
  InitializedHnswGraphBuilder.`fromGraph(RandomVectorScorerSupplier scorerSupplier, int M, int beamWidth, long seed, HnswGraph initializerGraph, int[] newOrdMap, BitSet initializedNodes, int totalNumberOfVectors)`
  Create a new HnswGraphBuilder that is initialized with the provided HnswGraph.
  `static MergingHnswGraphBuilder`
  MergingHnswGraphBuilder.`fromGraphs(RandomVectorScorerSupplier scorerSupplier, int M, int beamWidth, long seed, HnswGraph[] graphs, int[][] ordMaps, int totalNumberOfVectors, BitSet initializedNodes)`
  Create a new HnswGraphBuilder that is initialized with the provided HnswGraph.
  `static OnHeapHnswGraph`
  InitializedHnswGraphBuilder.`initGraph(int M, HnswGraph initializerGraph, int[] newOrdMap, int totalNumberOfVectors)`
  `static void`
  HnswGraphSearcher.`search(RandomVectorScorer scorer, KnnCollector knnCollector, HnswGraph graph, Bits acceptOrds)`
  See `HnswGraphSearcher.search(RandomVectorScorer, KnnCollector, HnswGraph, Bits, int)`
  `static void`
  HnswGraphSearcher.`search(RandomVectorScorer scorer, KnnCollector knnCollector, HnswGraph graph, Bits acceptOrds, int filteredDocCount)`
  Searches the HNSW graph for the nearest neighbors of a query vector.
  `HnswGraphBuilder.GraphBuilderKnnCollector`
  HnswGraphSearcher.`searchLevel(RandomVectorScorer scorer, int topK, int level, int[] eps, HnswGraph graph)`
  Searches for the nearest neighbors of a query vector in a given level.